FrontEnd

## Classes

class | scim::FrontEndError
| An exception class to hold FrontEnd related errors. More...
class | scim::FrontEndBase
| The base class to implement the FrontEnd objects. More...
class | scim::FrontEndModule
| The class to manipulate the frontend modules. More...

## Typedefs

typedef Pointer< FrontEndBase > | scim::FrontEndPointer
typedef void(* | scim::FrontEndModuleInitFunc) (const BackEndPointer &backend, const ConfigPointer &config, int argc, char **argv)
| Initialize a FrontEnd Module.
typedef void(* | scim::FrontEndModuleRunFunc) (void)
| Run a FrontEnd Module.

## Functions

int | scim::scim_get_frontend_module_list (std::vector< String > &mod_list)
| Get a name list of currently available frontend modules.

## Detailed Description

The base classes for FrontEnd modules.

## Typedef Documentation

## FrontEndPointer

typedef Pointer<FrontEndBase> scim::FrontEndPointer

A smart pointer for scim::FrontEndBase and its derived classes.

## FrontEndModuleInitFunc

typedef void(* scim::FrontEndModuleInitFunc) (const BackEndPointer &backend, const ConfigPointer &config, int argc, char **argv)

Initialize a FrontEnd Module.

There must be a function called "scim_frontend_module_init" in each frontend module which complies with this prototype. This function name can have a prefix like x11_LTX_, in which "x11" is the module's name.

Parameters

  backend | - a BackEnd instance which hold all IMEngineFactory instances.
  config | - a ConfigBase instance to maintain the configuration.

## FrontEndModuleRunFunc

typedef void(* scim::FrontEndModuleRunFunc) (void)

Run a FrontEnd Module.

There must be a function called "scim_frontend_module_run" in each frontend module which complies with this prototype. This function name can have a prefix like x11_LTX_, in which "x11" is the module's name.

## Function Documentation

## scim_get_frontend_module_list()

int scim::scim_get_frontend_module_list | ( | std::vector< String > & | mod_list | ) |

Get a name list of currently available frontend modules.

Parameters

  mod_list | - the result list will be stored here.

Returns
  the number of the modules, equal to mod_list.size ().